#!/usr/bin/env python
# -*- coding: UTF-8 -*-
import dbus
import dbus.service
import sys
import os
import json
import logging
import platform
import traceback
import thread
import urllib, urllib2
import ConfigParser

import subprocess
from subprocess import Popen, PIPE

import commands
import time
# from apscheduler.schedulers.background import BackgroundScheduler
from datetime import datetime
from threading import Timer

import gi
gi.require_version('Gtk', '3.0')
from gi.repository import GLib, Gtk


# set dbus msg
global dbus_name
global dbus_path
global dbus_iface
global dbus_client_name
global dbus_client_path
global dbus_client_iface
global test_pkgname
dbus_name = "org.cdos.update"
dbus_path = "/org/cdos/update"
dbus_iface = "org.cdos.update"
dbus_client_name = "org.cdos.update.client"
dbus_client_path = "/org/cdos/update/client"
dbus_client_iface = "org.cdos.update.client"

test_pkgname = "cdos-api-tests"


#logging.basicConfig(format= '%(levelname)s %(asctime)-15s %(message)s file:%(filename)s line:%(lineno)d', filename='/var/log/cdosupdate-daemon-test.log',level=logging.DEBUG)

import apt_pkg



class CDOSUpdateDaemon(dbus.service.Object):

    def __init__(self):
        self.session_bus = dbus.SessionBus()
        name = dbus.service.BusName(dbus_name, bus=self.session_bus)
        dbus.service.Object.__init__(self, name, dbus_path)
        # self.send_signal()

    @dbus.service.method(dbus_iface, in_signature='a{sv}', out_signature='bs')
    def downloadAppUpdate(self, download_meta_data):
        if not ("package_name" in download_meta_data and "version" in download_meta_data \
            and "env_home" in download_meta_data and "env_path" in download_meta_data \
            and "env_user" in download_meta_data and "env_display" in download_meta_data):
            return False, "paramaters error"
        print "download update:", download_meta_data["package_name"], download_meta_data["version"]
        if download_meta_data["package_name"] == test_pkgname:
            thread.start_new_thread(self.do_send_download_signal, (self,))
            return True, ""
        else:
            return False, "DownloadRequestFailed"
    
    @dbus.service.method(dbus_iface, in_signature='a{sv}', out_signature='bs')
    def installAppUpdate(self, install_meta_data):
        if not ("package_name" in install_meta_data and "version" in install_meta_data \
            and "pid" in install_meta_data and "process_name" in install_meta_data \
            and "env_home" in install_meta_data and "env_path" in install_meta_data \
            and "env_user" in install_meta_data and "env_display" in install_meta_data and "exit_flag" in install_meta_data):
            return False, "paramaters error"
        print "install update:", install_meta_data["package_name"], install_meta_data["version"]
        print "The exit flag:", install_meta_data["exit_flag"]
        if install_meta_data["package_name"] == test_pkgname:
            thread.start_new_thread(self.do_send_install_signal, (self,))
            return True, ""
        else:
            return False, "InstallRequestFailed"

    @dbus.service.signal(dbus_interface=dbus_iface, signature='sssis',)
    def appDownloadProgressChanged(self, package_name, version, status, process, err_reason):
        pass
    
    @dbus.service.signal(dbus_interface=dbus_iface, signature='sssis',)
    def appInstallProgressChanged(self, package_name, version, status, process, err_reason):
        pass
    
    def send_appDownloadSignal(self, package_name, version, status, process, err_reason):
        self.appDownloadProgressChanged(package_name, version, status, process, err_reason)
    
    def send_appInstallSignal(self, package_name, version, status, process, err_reason):
        self.appInstallProgressChanged(package_name, version, status, process, err_reason)
    
    def do_send_download_signal(self, argu):
        progress = 0
        signal_flag = True
        while signal_flag:
            time.sleep(4)
            progress += 25
            if progress < 100 and progress != 75:
                self.send_appDownloadSignal(test_pkgname, "1.0.0", "inprogress", progress, "")
                print "Download in progress"
            elif progress == 75:
                self.send_appDownloadSignal(test_pkgname, "1.0.0", "failed", progress, "DownloadFailed")
                print "DownloadFailed"
            elif progress == 100:
                self.send_appDownloadSignal(test_pkgname, "1.0.0", "success", progress, "")
                print "Download success"
            else:
                signal_flag = False
                
        thread.exit_thread()
    
    def do_send_install_signal(self, argu):
        progress = 0
        signal_flag = True
        while signal_flag:
            time.sleep(6)
            progress += 20
            if progress < 100:
                self.send_appInstallSignal(test_pkgname, "1.0.0", "inprogress", progress, "")
                print "Install in progress"
            elif progress == 100:
                self.send_appInstallSignal(test_pkgname, "1.0.0", "success", progress, "")
                print "Install success"
            else:
                self.send_appInstallSignal(test_pkgname, "1.0.0", "failed", progress, "InstallFailed")
                signal_flag = False
                print "InstallFailed"
        thread.exit_thread()    

    @dbus.service.method(dbus_iface, in_signature='s', out_signature='bas')
    def checkAppUpdate(self, package_name):
        print("check update: package is", package_name)
        if package_name == test_pkgname:
            print "return true"
            return True, ["2.0.0", "3.0.0"]
        else:
            print "return false"
            return False, []

    @dbus.service.method(dbus_iface, in_signature='s', out_signature='bs')
    def cancelAppUpdate(self, package_name):
        print("cancel update: package is", package_name)
        if package_name == test_pkgname:
            return True, ""
        else:
            return False, "CancelFailed"
    
    # @dbus.service.method(dbus_iface, in_signature='sss', out_signature='bs')
    # def setAppUpdateMode(self, package_name, update_mode, process_name):
    #     print("set app update mode: package is", package_name, "update mode is", update_mode, "process_name is", process_name)
    #     if package_name == test_pkgname:
    #         return True, ""
    #     else:
    #         return False, "SetModeFailed"
    
    # @dbus.service.method(dbus_iface, in_signature='s', out_signature='s')
    # def getAppUpdateMode(self, package_name):
    #     print("get app update mode: package is", package_name)
    #     return "AUTO_UPDATE"

class CDOSUpdateClientDaemon(dbus.service.Object):

    def __init__(self):
        self.session_bus = dbus.SessionBus()
        name = dbus.service.BusName(dbus_client_name, bus=self.session_bus)
        dbus.service.Object.__init__(self, name, dbus_client_path)
        # self.send_signal()

    @dbus.service.method(dbus_client_iface, in_signature='sss', out_signature='bs')
    def setAppUpdateMode(self, package_name, update_mode, process_name):
        print("set app update mode: package is", package_name, "update mode is", update_mode, "process_name is", process_name)
        if package_name == test_pkgname:
            return True, ""
        else:
            return False, "SetModeFailed"
    
    @dbus.service.method(dbus_client_iface, in_signature='s', out_signature='s')
    def getAppUpdateMode(self, package_name):
        print("get app update mode: package is", package_name)
        return "AUTO_UPDATE"


if __name__ == '__main__':
    # using glib
    import dbus.mainloop.glib
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    from gi.repository import GObject
    GObject.threads_init()
    loop = GObject.MainLoop()
    updatedaemon = CDOSUpdateDaemon()
    updateclientdaemon = CDOSUpdateClientDaemon()
    loop.run()


